
import datamgr.DataReader;

import java.util.Hashtable;
import java.util.Vector;
import java.util.Random;
import java.io.FileOutputStream;

/**
 * Created by IntelliJ IDEA.
 * User: dragomir
 * Date: Oct 1, 2007
 * Time: 6:33:57 PM
 * To change this template use File | Settings | File Templates.
 */
public class RandomSample {
    Hashtable sample = new Hashtable();

    public RandomSample() throws Exception {
        String inFile1 = "./data/lightcurves/nndists_9K_sorted_ts";
        String inFile2 = "./data/lightcurves/nndists_9K_sorted";
        int sampleSize = 100;
        int dbSize = 5000; //get random sample among the first 5000 elements, the more typical ones
        drawSampleInds(dbSize, sampleSize);
        drawSample(inFile1, inFile2);
    }

    private void drawSampleInds(int dbSize, int sampleSize) {
        Vector varr = new Vector();
        for (int i = 0; i < dbSize; i++) {
            varr.add(new Integer(i));
        }
        Random rnd = new Random(System.currentTimeMillis());
        for (int i = 0; i < sampleSize; i++) {
            int nextInt = rnd.nextInt(varr.size());
            Integer nextRndEl = (Integer) varr.get(nextInt);
            sample.put(nextRndEl, "");
        }
    }

    private void drawSample(String inFile1, String inFile2) throws Exception {
        FileOutputStream fos1 = new FileOutputStream(inFile1 + "_sample");
        FileOutputStream fos2 = new FileOutputStream(inFile2 + "_sample");
        DataReader r1 = new DataReader(inFile1, ' ');
        DataReader r2 = new DataReader(inFile2, ' ');

        String line1;
        String line2;
        int count = 0;
        while ((line1 = r1.readLineNoTokenize()) != null) {
            line2 = r2.readLineNoTokenize();
            if (sample.get(new Integer(count)) != null) {
                fos1.write((line1 + "\n").getBytes());
                fos2.write((line2 + "\n").getBytes());
            }
            count++;
        }
        fos1.close();
        fos2.close();
        r1.close();
        r2.close();
    }

    public static void main(String[] args) throws Exception {
        new RandomSample();
    }
}
